package com.thebrokenrail.energonrelics.util;

import net.minecraft.util.math.BlockPos;
import net.minecraft.util.registry.RegistryKey;
import net.minecraft.world.World;

/**
 * Block Position Including Dimension
 */
public class BlockPosWithDimension {
    /**
     * Position
     */
    public final BlockPos pos;
    /**
     * Dimension
     */
    public final RegistryKey<World> dimension;

    /**
     * Create
     * @param pos Position
     * @param dimension Dimension
     */
    public BlockPosWithDimension(BlockPos pos, RegistryKey<World> dimension) {
        this.pos = pos;
        this.dimension = dimension;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        } else if (obj instanceof BlockPosWithDimension) {
            return pos.equals(((BlockPosWithDimension) obj).pos) && dimension.equals(((BlockPosWithDimension) obj).dimension);
        } else {
            return false;
        }
    }
}
